﻿using System;
using Newtonsoft.Json;

// NuGet package Json.NET from Newtonsoft

namespace jsonSerialization
{
    class Program
    {
        static void Main()
        {
            Teacher teacher1 = new Teacher("Anders", 123456);
            string teacherJsonString = JsonConvert.SerializeObject(teacher1);
            // the JSON string can be stored in a file or database, or sent to another host on a network
            // or simply written to the screen
            Console.WriteLine(teacherJsonString);

            Teacher teacherCopy = JsonConvert.DeserializeObject<Teacher>(teacherJsonString);
            Console.WriteLine(teacherCopy);

            Student student1 = new Student();
            student1.Name = "John";
            student1.Teachers[0] = teacher1;
            student1.TeacherList.Add(teacher1);
            string studentJsonString = JsonConvert.SerializeObject(student1);
            Console.WriteLine(studentJsonString);

            Student studentCopy = JsonConvert.DeserializeObject<Student>(studentJsonString);
            Console.WriteLine(studentCopy);
        }
    }
}
